﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;

using Infragistics.Win.UltraWinGanttView;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win;
using ProjectPlanning.Help;
using Infragistics.Win.UltraWinToolbars;
using System.Resources;
using Infragistics.Shared;
using Infragistics.Win.UltraMessageBox;
using Infragistics.Win.UltraWinSchedule.TaskUI;
using Infragistics.Win.Printing;
using System.Reflection;
using Infragistics.Win.UltraWinGrid;
using System.Data;
using Infragistics.Win.UltraWinGanttView.UIElements;
using Infragistics.Win.UltraWinSchedule.TimelineView;

namespace ProjectPlanning
{
    public partial class Form1 : Form
    {
        
        public Form1()
        {
            InitializeComponent();

            //  Call the method that creates Fills the DataSet
            dbComm.fillProjects();
        }


        private void ultraPanel1_PaintClient_1(object sender, PaintEventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //GRID AAN Projects koppelen
            this.ugProjects.SetDataBinding(dbComm.ds, "Projects");
            this.ugProjects.DisplayLayout.ViewStyle = Infragistics.Win.UltraWinGrid.ViewStyle.SingleBand;
            //this.ugProjects.DisplayLayout.Bands[0].Columns["ProjectID"].Hidden = true;

            //  Set the BindingContextControl property to reference this form
            this.ultraCalendarInfo1.DataBindingsForTasks.BindingContextControl = this;
            this.ultraCalendarInfo1.DataBindingsForProjects.BindingContextControl = this;

            //  Set the DataBinding members for Projects
            this.ultraCalendarInfo1.DataBindingsForProjects.SetDataBinding(dbComm.ds, "Projects");
            this.ultraCalendarInfo1.DataBindingsForProjects.IdMember = "ProjectID";
            this.ultraCalendarInfo1.DataBindingsForProjects.KeyMember = "ProjectKey";
            this.ultraCalendarInfo1.DataBindingsForProjects.NameMember = "ProjectName";
            this.ultraCalendarInfo1.DataBindingsForProjects.StartDateMember = "ProjectStartTime";
            //  Set the DataBinding members for Tasks
            this.ultraCalendarInfo1.DataBindingsForTasks.SetDataBinding(dbComm.ds, "Tasks");
            // Basic Task properties
            this.ultraCalendarInfo1.DataBindingsForTasks.NameMember = "TaskName";
            this.ultraCalendarInfo1.DataBindingsForTasks.DurationMember = "TaskDuration";
            this.ultraCalendarInfo1.DataBindingsForTasks.StartDateTimeMember = "TaskStartTime";
            this.ultraCalendarInfo1.DataBindingsForTasks.IdMember = "TaskID";
            this.ultraCalendarInfo1.DataBindingsForTasks.ProjectKeyMember = "ProjectKey";
            this.ultraCalendarInfo1.DataBindingsForTasks.ParentTaskIdMember = "ParentTaskID";
            this.ultraCalendarInfo1.DataBindingsForTasks.ConstraintMember = "Constraint";
            this.ultraCalendarInfo1.DataBindingsForTasks.PercentCompleteMember = "TaskPercentComplete";
            // All other properties
            this.ultraCalendarInfo1.DataBindingsForTasks.AllPropertiesMember = "AllProperties";

            //  Since we are showing a task that belongs to an explicitly defined
            //  project (i.e., not the UnassignedProject), assign that project to
            //  the control's Project property so the control knows to display that project.
            this.ultraGanttView1.CalendarInfo = this.ultraCalendarInfo1;
            if (this.ultraGanttView1.CalendarInfo.Projects.Count == 1)
            {
                this.ultraGanttView1.Enabled = false;
            } else
            {
                this.ultraGanttView1.Project = this.ultraGanttView1.CalendarInfo.Projects[1];
            }
           
            this.ultraCalendarInfo1.TaskWorkingHourMode = TaskWorkingHourMode.AutoAdjust;

        }

        ///////////////////////////////////////////////////////
        // EVENTS
        ///////////////////////////////////////////////////////
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Project prj = this.ultraGanttView1.Project;
            this.saveProject(prj);
        }

        private void ugProjects_BeforeRowActivate(object sender, Infragistics.Win.UltraWinGrid.RowEventArgs e)
        {
            if (!this.rowDeleted) {
                Project prj = this.ultraGanttView1.Project;
                this.saveProject(prj);
            }
            this.rowDeleted = false;
        }

        private void saveProject(Project prj)
        {
            if (prj != null) {
                dbComm.saveProject(prj);
                this.ultraGanttView1.Project = this.ultraGanttView1.CalendarInfo.Projects[prj.Key];
            }
        }



        private void ugProjects_AfterRowActivate(object sender, EventArgs e)
        {
            if (!this.rowAdding) {
                String prjKey = (String)this.ugProjects.ActiveRow.GetCellValue("ProjectKey");
                dbComm.fillTasks(prjKey);
                this.ultraGanttView1.Project = this.ultraGanttView1.CalendarInfo.Projects[prjKey];
            }
            this.ultraGanttView1.Enabled = true;
        }

        private Boolean rowAdding;
        private void ugProjects_BeforeRowInsert(object sender, Infragistics.Win.UltraWinGrid.BeforeRowInsertEventArgs e)
        {
            this.rowAdding = true;
        }

        private void ugProjects_AfterRowInsert(object sender, Infragistics.Win.UltraWinGrid.RowEventArgs e)
        {
            if(this.ugProjects.ActiveRow != null) { 
                this.ugProjects.ActiveRow.Cells["ProjectID"].Value = Guid.NewGuid();
                this.rowAdding = false;
            } else
            {
                dbComm.addProject();
                this.rowAdding = false;
            }
            
        }

        public Boolean rowDeleted;
        private void ugProjects_AfterRowsDeleted(object sender, EventArgs e)
        {
            this.rowDeleted = true;
            dbComm.saveProjects();

            if (this.ultraGanttView1.CalendarInfo.Projects.Count == 1)
            {
                this.ultraGanttView1.Enabled = false;
            }

        }

        private void ugProjects_AfterRowUpdate(object sender, Infragistics.Win.UltraWinGrid.RowEventArgs e)
        {
            dbComm.saveProjects();
        }

    }

}
