﻿using Infragistics.Win.UltraWinSchedule;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;

namespace ProjectPlanning.Help
{
    class dbComm
    {
        private static String srvName = "SRVNAME";
        private static String dbName = "DBNAME";
        private static String connStr = "Data Source =" + srvName + "; Initial Catalog =" + dbName + "; Integrated Security = SSPI";
        private static SqlConnection conn = new SqlConnection(connStr);
        public static DataSet ds = new DataSet();
        private static SqlDataAdapter pda;
        private static SqlDataAdapter tda;


        public static void addProject()
        {
            ds.Tables["Projects"].Rows.Add(new object[] { Guid.NewGuid(),"Key 1","",DateTime.Now });
            saveProjects();
        }

        public static void fillProjects()
        {
            pda = new SqlDataAdapter();
            SqlCommand cmdP = conn.CreateCommand();
            cmdP.CommandText = "SELECT * FROM Project";
            pda.SelectCommand = cmdP;
            SqlCommandBuilder sqlCmdBuilderP;
            sqlCmdBuilderP = new SqlCommandBuilder(pda);

            pda.Fill(ds, "Projects");

            if(ds.Tables["Projects"].Rows.Count > 0)
            {
                DataRow prjRow = ds.Tables["Projects"].Rows[0];
                fillTasks((String)prjRow["ProjectKey"]);
                ds.Relations.Add(ds.Tables["Projects"].Columns["ProjectKey"], ds.Tables["Tasks"].Columns["ProjectKey"]);
            } else
            {
                //When the projects table doesn't have any rows just fill the table definition
                tda = new SqlDataAdapter();
                SqlCommand cmdT = conn.CreateCommand();
                cmdT.CommandText = "SELECT * FROM Task";
                tda.SelectCommand = cmdT;
                SqlCommandBuilder sqlCmdBuilderT;
                sqlCmdBuilderT = new SqlCommandBuilder(tda);
                tda.Fill(ds, "Tasks");
                ds.Tables["Tasks"].AcceptChanges();
            }
        }

        public static void saveProjects()
        {
            pda.Update(ds, "Projects");
            ds.Tables["Projects"].AcceptChanges();
        }

        public static void saveProject(Project prj)
        {
            //Code is necessary to set the order that it is the same as it is visually
            int rowNumber = 0;
            for (int i = 0; i < prj.Tasks.Count; i++)
            {
                DataRow[] taskRow = ds.Tables["Tasks"].Select("TaskID = '" + prj.Tasks[i].Id + "'");
                if (taskRow.Length == 1)
                {
                    taskRow[0]["RowIndex"] = rowNumber;
                    taskRow[0]["ProjectKey"] = prj.Key;
                    rowNumber++;
                    rowNumber = changeRowNumberSubTasks(rowNumber, prj.Key, prj.Tasks[i]);
                }
            }
            tda.Update(ds, "Tasks");
            ds.AcceptChanges();
        }

        private static int changeRowNumberSubTasks(int rowNumber, String projectKey, Task t)
        {
            int rNumber = rowNumber;
            if (t.Tasks.Count != 0)
            {
                for (int i = 0; i < t.Tasks.Count; i++)
                {
                    DataRow[] taskRow = ds.Tables["Tasks"].Select("TaskID = '" + t.Tasks[i].Id + "'");
                    if (taskRow.Length == 1)
                    {
                        taskRow[0]["RowIndex"] = rNumber;
                        taskRow[0]["ProjectKey"] = projectKey;
                        rNumber++;
                        rNumber = changeRowNumberSubTasks(rNumber, projectKey, t.Tasks[i]);
                    }
                }
            }
            return rNumber;
        }

        public static void fillTasks(String prjKey)
        {
            if (ds.Tables["Tasks"] != null)
            {
                ds.Tables["Tasks"].Clear();
                ds.Tables["Tasks"].AcceptChanges();
            }

            tda = new SqlDataAdapter();
            SqlCommand cmdT = conn.CreateCommand();
            cmdT.CommandText = "SELECT * FROM Task Where ProjectKey = '" + prjKey + "' order by ProjectKey, RowIndex";
            tda.SelectCommand = cmdT;
            SqlCommandBuilder sqlCmdBuilderT;
            sqlCmdBuilderT = new SqlCommandBuilder(tda);
            tda.Fill(ds, "Tasks");
            ds.Tables["Tasks"].AcceptChanges();

        }

    }
}
